#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * SalutSvcChannelInterfaceTube:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcChannelInterfaceTube SalutSvcChannelInterfaceTube;

/**
 * SalutSvcChannelInterfaceTubeClass:
 *
 * The class of SalutSvcChannelInterfaceTube.
 */
typedef struct _SalutSvcChannelInterfaceTubeClass SalutSvcChannelInterfaceTubeClass;

GType salut_svc_channel_interface_tube_get_type (void);
#define SALUT_TYPE_SVC_CHANNEL_INTERFACE_TUBE \
  (salut_svc_channel_interface_tube_get_type ())
#define SALUT_SVC_CHANNEL_INTERFACE_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_CHANNEL_INTERFACE_TUBE, SalutSvcChannelInterfaceTube))
#define SALUT_IS_SVC_CHANNEL_INTERFACE_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_CHANNEL_INTERFACE_TUBE))
#define SALUT_SVC_CHANNEL_INTERFACE_TUBE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_CHANNEL_INTERFACE_TUBE, SalutSvcChannelInterfaceTubeClass))


void salut_svc_channel_interface_tube_emit_tube_channel_state_changed (gpointer instance,
    guint arg_state);

/**
 * SalutSvcChannelTypeDBusTube:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcChannelTypeDBusTube SalutSvcChannelTypeDBusTube;

/**
 * SalutSvcChannelTypeDBusTubeClass:
 *
 * The class of SalutSvcChannelTypeDBusTube.
 */
typedef struct _SalutSvcChannelTypeDBusTubeClass SalutSvcChannelTypeDBusTubeClass;

GType salut_svc_channel_type_dbus_tube_get_type (void);
#define SALUT_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE \
  (salut_svc_channel_type_dbus_tube_get_type ())
#define SALUT_SVC_CHANNEL_TYPE_DBUS_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE, SalutSvcChannelTypeDBusTube))
#define SALUT_IS_SVC_CHANNEL_TYPE_DBUS_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE))
#define SALUT_SVC_CHANNEL_TYPE_DBUS_TUBE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE, SalutSvcChannelTypeDBusTubeClass))


typedef void (*salut_svc_channel_type_dbus_tube_offer_d_bus_tube_impl) (SalutSvcChannelTypeDBusTube *self,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_dbus_tube_implement_offer_d_bus_tube (SalutSvcChannelTypeDBusTubeClass *klass, salut_svc_channel_type_dbus_tube_offer_d_bus_tube_impl impl);
/**
 * salut_svc_channel_type_dbus_tube_return_from_offer_d_bus_tube:
 * @context: The D-Bus method invocation context
 * @out_address: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_dbus_tube_return_from_offer_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address);
static inline void
salut_svc_channel_type_dbus_tube_return_from_offer_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address)
{
  dbus_g_method_return (context,
      out_address);
}

typedef void (*salut_svc_channel_type_dbus_tube_accept_d_bus_tube_impl) (SalutSvcChannelTypeDBusTube *self,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_dbus_tube_implement_accept_d_bus_tube (SalutSvcChannelTypeDBusTubeClass *klass, salut_svc_channel_type_dbus_tube_accept_d_bus_tube_impl impl);
/**
 * salut_svc_channel_type_dbus_tube_return_from_accept_d_bus_tube:
 * @context: The D-Bus method invocation context
 * @out_address: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_dbus_tube_return_from_accept_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address);
static inline void
salut_svc_channel_type_dbus_tube_return_from_accept_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address)
{
  dbus_g_method_return (context,
      out_address);
}

void salut_svc_channel_type_dbus_tube_emit_d_bus_names_changed (gpointer instance,
    GHashTable *arg_added,
    const GArray *arg_removed);

/**
 * SalutSvcChannelTypeStreamTube:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcChannelTypeStreamTube SalutSvcChannelTypeStreamTube;

/**
 * SalutSvcChannelTypeStreamTubeClass:
 *
 * The class of SalutSvcChannelTypeStreamTube.
 */
typedef struct _SalutSvcChannelTypeStreamTubeClass SalutSvcChannelTypeStreamTubeClass;

GType salut_svc_channel_type_stream_tube_get_type (void);
#define SALUT_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE \
  (salut_svc_channel_type_stream_tube_get_type ())
#define SALUT_SVC_CHANNEL_TYPE_STREAM_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE, SalutSvcChannelTypeStreamTube))
#define SALUT_IS_SVC_CHANNEL_TYPE_STREAM_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE))
#define SALUT_SVC_CHANNEL_TYPE_STREAM_TUBE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE, SalutSvcChannelTypeStreamTubeClass))


typedef void (*salut_svc_channel_type_stream_tube_offer_stream_tube_impl) (SalutSvcChannelTypeStreamTube *self,
    guint in_address_type,
    const GValue *in_address,
    guint in_access_control,
    const GValue *in_access_control_param,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_stream_tube_implement_offer_stream_tube (SalutSvcChannelTypeStreamTubeClass *klass, salut_svc_channel_type_stream_tube_offer_stream_tube_impl impl);
/**
 * salut_svc_channel_type_stream_tube_return_from_offer_stream_tube:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_stream_tube_return_from_offer_stream_tube (DBusGMethodInvocation *context);
static inline void
salut_svc_channel_type_stream_tube_return_from_offer_stream_tube (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_channel_type_stream_tube_accept_stream_tube_impl) (SalutSvcChannelTypeStreamTube *self,
    guint in_address_type,
    guint in_access_control,
    const GValue *in_access_control_param,
    DBusGMethodInvocation *context);
void salut_svc_channel_type_stream_tube_implement_accept_stream_tube (SalutSvcChannelTypeStreamTubeClass *klass, salut_svc_channel_type_stream_tube_accept_stream_tube_impl impl);
/**
 * salut_svc_channel_type_stream_tube_return_from_accept_stream_tube:
 * @context: The D-Bus method invocation context
 * @out_address: const GValue * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_channel_type_stream_tube_return_from_accept_stream_tube (DBusGMethodInvocation *context,
    const GValue *out_address);
static inline void
salut_svc_channel_type_stream_tube_return_from_accept_stream_tube (DBusGMethodInvocation *context,
    const GValue *out_address)
{
  dbus_g_method_return (context,
      out_address);
}

void salut_svc_channel_type_stream_tube_emit_stream_tube_new_connection (gpointer instance,
    guint arg_handle);

/**
 * SalutSvcOLPCActivityProperties:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcOLPCActivityProperties SalutSvcOLPCActivityProperties;

/**
 * SalutSvcOLPCActivityPropertiesClass:
 *
 * The class of SalutSvcOLPCActivityProperties.
 */
typedef struct _SalutSvcOLPCActivityPropertiesClass SalutSvcOLPCActivityPropertiesClass;

GType salut_svc_olpc_activity_properties_get_type (void);
#define SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES \
  (salut_svc_olpc_activity_properties_get_type ())
#define SALUT_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, SalutSvcOLPCActivityProperties))
#define SALUT_IS_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES))
#define SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, SalutSvcOLPCActivityPropertiesClass))


typedef void (*salut_svc_olpc_activity_properties_set_properties_impl) (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_set_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_set_properties_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_activity_properties_get_properties_impl) (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_get_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_get_properties_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
salut_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

void salut_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties);

/**
 * SalutSvcOLPCBuddyInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcOLPCBuddyInfo SalutSvcOLPCBuddyInfo;

/**
 * SalutSvcOLPCBuddyInfoClass:
 *
 * The class of SalutSvcOLPCBuddyInfo.
 */
typedef struct _SalutSvcOLPCBuddyInfoClass SalutSvcOLPCBuddyInfoClass;

GType salut_svc_olpc_buddy_info_get_type (void);
#define SALUT_TYPE_SVC_OLPC_BUDDY_INFO \
  (salut_svc_olpc_buddy_info_get_type ())
#define SALUT_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO, SalutSvcOLPCBuddyInfo))
#define SALUT_IS_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO))
#define SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO, SalutSvcOLPCBuddyInfoClass))


typedef void (*salut_svc_olpc_buddy_info_set_properties_impl) (SalutSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_properties_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_properties_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_properties_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
salut_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

typedef void (*salut_svc_olpc_buddy_info_set_activities_impl) (SalutSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_activities_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_activities:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_activities_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_activities_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_activities:
 * @context: The D-Bus method invocation context
 * @out_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities);
static inline void
salut_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities)
{
  dbus_g_method_return (context,
      out_activities);
}

typedef void (*salut_svc_olpc_buddy_info_set_current_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_current_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_current_activity:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_current_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_current_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_current_activity:
 * @context: The D-Bus method invocation context
 * @out_activity: const gchar * (FIXME, generate documentation)
 * @out_channel: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel);
static inline void
salut_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel)
{
  dbus_g_method_return (context,
      out_activity,
      out_channel);
}

void salut_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties);
void salut_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities);
void salut_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel);


G_END_DECLS
